/** VGB: portable GameBoy emulator ***************************/
/**                                                         **/
/**                          Help.h                         **/
/**                                                         **/
/** This file contains help information printed out by the  **/
/** main() routine when started with option "-help".        **/
/**                                                         **/
/** Copyright (C) Marat Fayzullin 1994,1995                 **/
/**     You are not allowed to distribute this software     **/
/**     commercially. Please, notify me, if you make any    **/
/**     changes to this file.                               **/
/*************************************************************/

char *HelpText[] =
{
  "\nUsage: vgb [-option1 [-option2...]] <filename>",
  "<filename> = name of file to load as cartridge [CART.GB]",
  "[-option]   =",
  "  -verbose <level>    - Select debugging messages [5]",
  "                        0 - Silent           1 - Startup messages",
  "                        2 - Illegal writes   4 - Illegal CPU ops",
  "                        8 - Bank switching", 
  "  -vperiod <period>   - Set VBlank interrupts period [69905 cycles]",
  "  -uperiod <period>   - Number of interrupts per screen update [2]",
  "  -help               - Print this help page",
  "  -cheat <GG code>    - Activate a GameGenie cheat",
  "  -delay/-nodelay     - Delay/don't delay line interrupts [-nodelay]",
  "  -crc/-nocrc         - Check/don't check cartridge CRC [-crc]",
  "  -autoa/-noautoa     - Autofire/No autofire for button A [-noautoa]",
  "  -autob/-noautob     - Autofire/No autofire for button B [-noautob]",
  "  -logsnd <filename>  - Write soundtrack to a file [off]", 
#ifdef DEBUG
  "  -trap <address>     - Trap execution when PC reaches address [FFFFh]",
#endif
#ifdef MITSHM
  "  -shm/-noshm         - Use/don't use MIT SHM extensions for X [-shm]",
#endif
#ifdef UNIX
  "  -saver/-nosaver     - Save/don't save CPU when inactive [-saver]",
  "  -colorN <name>      - Change color #N [white,#989898,#585858,black]",
  "  -bcolorN <name>     - Change background color #N [same]",
  "  -scolorN <name>     - Change sprite color #N [same]",
  "  -wcolorN <name>     - Change window color #N [same]",
#endif
  "\nKeyboard bindings:",
  "  [SPACE] - A button (also: A,S,D,F,G,H,J,K,L)",
  "  [LALT]  - B button (also: Z,X,C,V,B,N,M)",
  "  [TAB]   - SELECT button",
  "  [ENTER] - START button",
  "  [ESC]   - Quit emulation (also: [F12])",
#ifdef DEBUG
  "\n  [F1]    - Go into built-in debugger",
  "  [F2]    - Show LCD controller registers",
#endif
  NULL
};
