/*
 *  This file is part of ixnet.library for the Amiga.
 *  Copyright (C) 1996 Jeff Shepherd
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  $Id: $
 *
 *  $Log:$
 *
 */


#define _KERNEL
#include "ixnet.h"
#include "kprintf.h"
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

int setuid(uid_t uid)
{
  struct ixnet *p = (struct ixnet *)u.u_ixnet;

  if (p->u_networkprotocol == IX_NETWORK_AMITCP)
    return UG_setuid(uid);
  return 0;
}

int seteuid(uid_t uid)
{
  return setreuid(getuid(),uid);
}

int setreuid(int ruid, int euid) 
{
  struct ixnet *p = (struct ixnet *)u.u_ixnet;

  if (p->u_networkprotocol == IX_NETWORK_AMITCP)
    return UG_setreuid(ruid, euid);
  return 0;
}

uid_t
getuid(void)
{
    register struct ixnet *p = (struct ixnet *)u.u_ixnet;
    register int network_protocol = p->u_networkprotocol;
    uid_t retval;

    switch(network_protocol) {
	case IX_NETWORK_AMITCP:
	    retval = UG_getuid();
	break;

	default: /* case IX_NETWORK_AS225: */
	    retval = SOCK_getuid();
	break;
    }
    return retval;
}

uid_t
geteuid(void)
{
    register struct ixnet *p = (struct ixnet *)u.u_ixnet;
    register int network_protocol = p->u_networkprotocol;

    switch(network_protocol) {
	case IX_NETWORK_AMITCP:
	    return UG_geteuid();

	default: /* case IX_NETWORK_AS225: */
	    return SOCK_getuid();
    }
}

