 /*
  * UAE - The Un*x Amiga Emulator
  *
  * DOS Sound Blaster interface.
  *
  * (c) 1996 Peter Remmers
  */

/* internally used types */
typedef UWORD          BOOL;

typedef enum
{
  SB_Type_StdSB,
  SB_Type_SbPro,
  SB_Type_SB16
}
tSBType;

extern tSBType SB_Type;

extern volatile int           SB_Playing;
extern volatile unsigned long SB_Bytes_Played;

extern BOOL SB_Reset(void);
extern void SB_WriteDSP (UBYTE value);
extern UBYTE SB_ReadDSP (void);
extern void SB_WriteMixer (UBYTE reg, UBYTE data);
extern UBYTE SB_ReadMixer (UBYTE reg);
extern BOOL SB_DetectMixer (void);
extern UBYTE fifo_read (void);
extern void fifo_write (UBYTE val);
extern void fill_buffer (UBYTE buf);
extern void SB_Play_8Bit_Std (UWORD bytes);
extern void SB_Play_8Bit_SbPro (UWORD bytes);
extern void SB_Play_8Bit_SB16 (UWORD bytes);
extern void SB_Play_8Bit_SB16_Autoinit (UWORD bytes);
extern void SB_Play_16Bit (UWORD bytes);
extern void SB_Play_16Bit_Autoinit (UWORD bytes);
extern void SB_IntHandler_Single (void);
extern void SB_IntHandler_Autoinit (void);
extern void SB_IntHandler (void);
extern void SB_SetRate_LoSpeed (UWORD rate);
extern void SB_SetRate_HiSpeed (UWORD rate);
extern void SB_SetRate_SB16 (UWORD rate);
extern void calculate_buf_sizes(void);
extern int SB_SetRate (unsigned short rate);
extern int SB_SetBits (unsigned char bits);
extern int SB_SetChannels (unsigned char channels);
extern int SB_SetSigned (int sign);
extern void SB_SpeakerOff(void);
extern void SB_SpeakerOn(void);
extern void SB_Play (void);
extern void irq2 (void);
extern void irq5 (void);
extern void irq7 (void);
extern void irq10 (void);
extern int SB_Detect (unsigned short *base, unsigned short *irq,
		      unsigned short *dmalo, unsigned short *dmahi);
extern int SB_Init (unsigned short base, unsigned short irq,
		    unsigned short dmalo, unsigned short dmahi);
extern void SB_Done (void);
extern void SB_Write (void *buf, unsigned long size);
extern void SB_Flush (void);
extern void SB_Stop (void);
extern void SB_Continue (void);
extern void SB_GetVersion (unsigned char *Maj, unsigned char *Min);
extern unsigned short SB_GetFragmentSize (void);
extern UWORD SB_GetBufferSize (void);
extern int SB_DetectInitSound(int *dspbits, int *dsprate, int *sndbufsize);
